题目链接:5274. 停在原地的方案数

You have a pointer at index 0 in an array of size arrLen. At each step, you can move 1 position to the left, 1 position to the right in the array or stay in the same place (The pointer should not be placed outside the array at any time).

Given two integers steps and arrLen, return the number of ways such that your pointer still at index 0 after exactly steps steps.

Since the answer may be too large, return it modulo \(10^9 + 7\).

Example 1:

Input: steps = 3, arrLen = 2
Output: 4
Explanation: There are 4 differents ways to stay at index 0 after 3 steps.
Right, Left, Stay
Stay, Right, Left
Right, Stay, Left
Stay, Stay, Stay

Example 2:

Input: steps = 2, arrLen = 4
Output: 2
Explanation: There are 2 differents ways to stay at index 0 after 2 steps
Right, Left
Stay, Stay

Example 3:

Input: steps = 4, arrLen = 2
Output: 8

Constraints:

  • 1 <= steps <= 500
  • 1 <= arrLen <= 10^6

题解

要想在第 n 步到达 0 点,那么第 n-1 步必须在 0 点或者 1 点,

要想第 n-1 步在 0 点,那么第 n-2 步必须在 0 点或者 1 点。

要想第 n-1 步在 1 点,那么第 n-2 步必须在 0 点,1 点,2 点。

...

...

由此看出这是动态规划的问题。

定义 int 型二维数组 dp[501][252],dp[i][j] 表示第 i 步到达 j 点的方案数。

因为 steps 最大为 500,下标从 0 开始,所以大小为 501,

因为 500 步之内想要回到 0 点,向右走最多 250 步,通过上面的步骤中第三行所示,需要向右多出一位,用来计算后面的值,所以要加 1,又因为下标从 0 开始,所以加 2。故大小为 252。

公式如下:$$dp[i][j]=\begin{cases}1&\text{}i=j=0\dp[i-1][j]+dp[i-1][j+1]&\text{}i>0且j=0\dp[i-1][j-1]+dp[i-1][j]+dp[i-1][j+1]&\text{}i>0且j>0\end{cases}$$

Example 1 计算步骤如下:

时间复杂度:\(O(m*min(\frac{m}{2}, n))\),m 表示 steps,n 表示 arrLen。

空间复杂度:\(O(1)\),因为大小固定,与 steps,arrLen 无关。

Java代码(第6次提交)

我发现最里面的判断执行的次数太多,而且好像可以提出来。

// 执行时间:7ms
class Solution {
public int numWays(int steps, int arrLen) {
int mod = 1000000007;
int[][] dp = new int[501][252];
dp[0][0] = 1;
int right = 0;
for (int i = 1; i <= steps; ++i) {
right = Math.min(Math.min(i, steps - i), arrLen - 1);
// 第0列只能加正上方和右上方,左上方出界了
dp[i][0] = (dp[i - 1][0] + dp[i - 1][1]) % mod;
for (int j = 1; j <= right; ++j) {// 从1开始
// 左上方和正上方
dp[i][j] = (dp[i - 1][j - 1] + dp[i - 1][j]) % mod;
dp[i][j] = (dp[i][j] + dp[i - 1][j + 1]) % mod;// 右上方
}
}
return dp[steps][0];
}
}

Java代码(第5次提交)

// 执行时间:9ms
class Solution {
public int numWays(int steps, int arrLen) {
int mod = 1000000007;
int[][] dp = new int[501][252];
dp[0][0] = 1;
int right = 0;
for (int i = 1; i <= steps; ++i) {
// 将这里直接用一行表示
right = Math.min(Math.min(i, steps - i), arrLen - 1);
for (int j = 0; j <= right; ++j) {
dp[i][j] = (dp[i][j] + dp[i - 1][j]) % mod;// 两行合为一行
if (j > 0) {
// 两行合为一行
dp[i][j] = (dp[i][j] + dp[i - 1][j - 1]) % mod;
}
// 两行合为一行
dp[i][j] = (dp[i][j] + dp[i - 1][j + 1]) % mod;
}
}
return dp[steps][0];
}
}

Java代码(第4次提交)

// 执行时间:11ms
class Solution {
public int numWays(int steps, int arrLen) {
int mod = 1000000007;
// 第3次太啰嗦,直接固定为最大范围更节省时间,快6ms,
// 这说明计算比申请内存(这里申请的空间也不大)更耗时
int[][] dp = new int[501][252];
dp[0][0] = 1;
int right = 0;
for (int i = 1; i <= steps; ++i) {
right = Math.min(i, steps - i);
right = Math.min(right, arrLen - 1);
for (int j = 0; j <= right; ++j) {
dp[i][j] += dp[i - 1][j];
dp[i][j] %= mod;
if (j > 0) {
dp[i][j] += dp[i - 1][j - 1];
dp[i][j] %= mod;
}
dp[i][j] += dp[i - 1][j + 1];
dp[i][j] %= mod;
}
}
return dp[steps][0];
}
}

Java代码(第3次提交)

其实步数最多为 500 步,所以最多向右走 250 步,如果继续向右走 1 步,那么就无法回到原点。所以 steps >> 1,又因为需要计算 dp[i][steps >> 1],所以右边还需要 1 位,因此要加 1,又因为这是下标(从 0 开始),所以最终是 (steps >> 1) + 2,但是又不能超过限定的范围。所以就变成了下面写的那样。

// 执行用时:17ms
class Solution {
public int numWays(int steps, int arrLen) {
int mod = 1000000007;
// 如此啰嗦
int[][] dp = new int[steps + 1][Math.min((steps >> 1) + 2, arrLen + 1)];
dp[0][0] = 1;
int right = 0;
for (int i = 1; i <= steps; ++i) {
right = Math.min(i, steps - i);
right = Math.min(right, arrLen - 1);
for (int j = 0; j <= right; ++j) {
dp[i][j] += dp[i - 1][j];
dp[i][j] %= mod;
if (j > 0) {
dp[i][j] += dp[i - 1][j - 1];
dp[i][j] %= mod;
}
dp[i][j] += dp[i - 1][j + 1];
dp[i][j] %= mod;
}
}
return dp[steps][0];
}
}

Java代码(第2次提交)

第1次提交的时候忘记将输出删掉,,,结果超时了。

第2次提交,内存超出限制。原因是 arrLen 达到 \(10^6\),导致数组过大。

class Solution {
public int numWays(int steps, int arrLen) {
int mod = 1000000007;
int[][] dp = new int[steps + 1][arrLen + 1];// 这里超出内存限制
dp[0][0] = 1;
int right = 0;
for (int i = 1; i <= steps; ++i) {
right = Math.min(i, steps - i);
right = Math.min(right, arrLen - 1);
for (int j = 0; j <= right; ++j) {
dp[i][j] += dp[i - 1][j];
dp[i][j] %= mod;
if (j > 0) {
dp[i][j] += dp[i - 1][j - 1];
dp[i][j] %= mod;
}
dp[i][j] += dp[i - 1][j + 1];
dp[i][j] %= mod;
}
}
return dp[steps][0];
}
// private void print(int[][] dp) {
// for (int i = 0; i < dp.length; ++i) {
// for (int j = 0; j < dp[i].length; ++j) {
// System.out.print(dp[i][j] + " ");
// }
// System.out.println();
// }
// System.out.println();
// }
}

原文链接https://www.cnblogs.com/wowpH/p/11924796.html

- End - wowpH - cnblogs -

LeetCode 5274. Number of Ways to Stay in the Same Place After Some Steps - Java - DP的更多相关文章

  1. 【leetcode】1269. Number of Ways to Stay in the Same Place After Some Steps

    题目如下: You have a pointer at index 0 in an array of size arrLen. At each step, you can move 1 positio ...

  2. leetcode面试准备:Decode Ways

    1 题目 A message containing letters from A-Z is being encoded to numbers using the following mapping: ...

  3. 【一天一道LeetCode】#91. Decode Ways

    一天一道LeetCode 本系列文章已全部上传至我的github,地址:ZeeCoder's Github 欢迎大家关注我的新浪微博,我的新浪微博 欢迎转载,转载请注明出处 (一)题目 A messa ...

  4. 【LeetCode】91. Decode Ways 解题报告(Python)

    [LeetCode]91. Decode Ways 解题报告(Python) 标签(空格分隔): LeetCode 作者: 负雪明烛 id: fuxuemingzhu 个人博客: http://fux ...

  5. cf466C Number of Ways

    C. Number of Ways time limit per test 2 seconds memory limit per test 256 megabytes input standard i ...

  6. 【LeetCode】91. Decode Ways

    题目: A message containing letters from A-Z is being encoded to numbers using the following mapping: ' ...

  7. C#版 - Leetcode 191. Number of 1 Bits-题解

    版权声明: 本文为博主Bravo Yeung(知乎UserName同名)的原创文章,欲转载请先私信获博主允许,转载时请附上网址 http://blog.csdn.net/lzuacm. C#版 - L ...

  8. [leetcode]200. Number of Islands岛屿个数

    Given a 2d grid map of '1's (land) and '0's (water), count the number of islands. An island is surro ...

  9. [leetcode]694. Number of Distinct Islands你究竟有几个异小岛?

    Given a non-empty 2D array grid of 0's and 1's, an island is a group of 1's (representing land) conn ...

随机推荐

  1. Python I/O编程 --读写文件、StringIO/ BytesIO

    I/O编程 Input/Output  输入/输出 Stream(流)是一个很重要的概念,可以把流想象成一个水管,数据就是水管里的水 Input Stream就是数据从外面(磁盘.网络)流进内存,Ou ...

  2. .net core 原生支持grpc

    文章转自:https://grpc.io/blog/grpc-on-dotnetcore This is a guest post by Sourabh Shirhatti, a Program Ma ...

  3. 帝国cms伪静态设置方法

    众所周知,动态页面不利于收录和排名.伪静态可以完美的解决这问题,配合百度云加速CDN,可以让动态页面有静态页面一样快的访问速度. 今天开拓族给大家带来帝国CMS伪静态的详细设置方法. 1.栏目设置为动 ...

  4. Java编程思想之七复用类

    复用代码是Java众多引人注目的功能之一.但要想成为极具革命性的语言,仅仅能够复制代码并对之加以改变是不够的,它还必须做更多的事情. 使用类而不破坏程序代码: 在新类中产生现有对象.由于新的类是由现有 ...

  5. C#实现图像拖拽以及锚点缩放功能

    本文主要实现C#窗体图像拖拽以及锚点缩放功能 1.新建Windows窗体应用项目,添加一个panel控件,在panel控件上添加picturebox控件 代码如下: using System; usi ...

  6. pandas.DataFrame.astype数据结构转换

    网易云课堂该课程链接地址 https://study.163.com/course/courseMain.htm?share=2&shareId=400000000398149&cou ...

  7. sql server中raiserror的用法(动态参数传值)

    1.raiserrror定义: 返回用户定义的错误信息并设系统标志,记录发生错误.通过使用 RAISERROR 语句,客户端可以从 sysmessages 表中检索条目, 或者使用用户指定的严重度和状 ...

  8. scrapy中的Pipeline

    当Item在Spider中被收集之后,它将会被传递到Item Pipeline,这些Item Pipeline组件按定义的顺序处理Item. 每个Item Pipeline都是实现了简单方法的Pyth ...

  9. Sword 哈希表

    哈希表 哈希表是一种典型的以空间换取时间的数据结构,在没有冲突的情况下,对任意元素的插入.索引.删除的时间复杂度都是O().这样优秀的时间复杂度是通过将元素的key值以hash方法f映射到哈希表中的某 ...

  10. C++ Map运用实例

    C++ Map运用实例 #include <map> #include <string> #include <iostream> #include <ioma ...